import { Counter } from "./components/Counter";
import { FetchData } from "./components/FetchData";
import Home from "./components/Home";
import CreateAccount from "./components/accounts/CreateAccount";
import DeleteAccount from "./components/accounts/DeleteAccount";
import UpdateAccount from "./components/accounts/UpdateAccount";
import Accounts from "./components/accounts/Accounts";
import Login from "./components/auth/Login";
import { Logout } from "./components/auth/Logout";
import Register from "./components/auth/Register";
import CreateUser from "./components/users/CreateUser";
import DeleteUser from "./components/users/DeleteUser";
import UpdateUser from "./components/users/UpdateUser";
import Users from "./components/users/Users";
import { Routes } from "./components/services/Routes";

import Transactions from "./components/transactions/Transactions";
import CreateTransaction from "./components/transactions/CreateTransaction";
import DeleteTransaction from "./components/transactions/DeleteTransaction";
import AccountDashboard from "./components/accounts/AccountDashboard";
import CreateEnvelope from "./components/envelope/CreateEnvelope";
import Envelopes from "./components/envelope/Envelopes";
import CreateAutoclassrule from "./components/autoclassrules/CreateAutoclassrule";
import DeleteAutoclassrule from "./components/autoclassrules/DeleteAutoclassrule";
import DeleteEnvelope from "./components/envelope/DeleteEnvelope";
import UpdateTransaction from "./components/transactions/UpdateTransaction";
import UpdateEnvelope from "./components/envelope/UpdateEnvelope";
import UpdateAutoclassrule from "./components/autoclassrules/UpdateAutoclassrule";
import ApiKeysPage from "./components/apikeys/ApiKeysPage";

const AppRoutes = [
  {
    index: true,
    element: <Home />
  },
  {
    path: Routes.HOME,
    element: <Home />
  },
  {
    path: Routes.COUNTER,
    element: <Counter />
  },
  {
    path: Routes.FETCH_DATA,
    element: <FetchData />
  },
  {
    path: Routes.LOGIN,
    element: <Login />
  },
  {
    path: Routes.LOGOUT,
    element: <Logout />
  },
  {
    path: Routes.REGISTER,
    element: <Register />
  },
  {
    path: Routes.USERS,
    element: <Users />
  },
  {
    path: Routes.USERS_CREATE,
    element: <CreateUser />
  },
  {
    path: Routes.USERS_EDIT,
    element: <UpdateUser />
  },
  {
    path: Routes.USERS_DELETE,
    element: <DeleteUser />
  },
  {
    path: Routes.ACCOUNTS,
    element: <Accounts />
  },
  {
    path: Routes.ACCOUNTS_DASHBOARD,
    element: <AccountDashboard />
  },
  {
    path: Routes.ACCOUNTS_CREATE,
    element: <CreateAccount />
  },
  {
    path: Routes.ACCOUNTS_EDIT,
    element: <UpdateAccount />
  },
  {
    path: Routes.ACCOUNTS_DELETE,
    element: <DeleteAccount />
  },
  {
    path: Routes.TRANSACTIONS,
    element: <Transactions />
  },
  {
    path: Routes.TRANSACTIONS_CREATE,
    element: <CreateTransaction />
  },
  {
    path: Routes.TRANSACTIONS_EDIT,
    element: <UpdateTransaction />
  },
  {
    path: Routes.TRANSACTIONS_DELETE,
    element: <DeleteTransaction />
  },
  {
    path: Routes.ENVELOPES,
    element: <Envelopes />
  },
  {
    path: Routes.ENVELOPES_CREATE,
    element: <CreateEnvelope />
  },
  {
    path: Routes.ENVELOPES_EDIT,
    element: <UpdateEnvelope />
  },
  {
    path: Routes.ENVELOPES_DELETE,
    element: <DeleteEnvelope />
  },
  {
    path: Routes.AUTOCLASS_CREATE,
    element: <CreateAutoclassrule />
  },
  {
    path: Routes.AUTOCLASS_EDIT,
    element: <UpdateAutoclassrule />
  },
  {
    path: Routes.AUTOCLASS_DELETE,
    element: <DeleteAutoclassrule />
  },
  {
    path: Routes.APIKEYS,
    element: <ApiKeysPage />
  },
];

export default AppRoutes;
