import React, { Component } from 'react';
import { Collapse, Navbar, NavbarBrand, NavbarToggler, NavItem, NavLink } from 'reactstrap';
import { Link } from 'react-router-dom';
import { Routes } from "./services/Routes";
import './NavMenu.css';

export class NavMenu extends Component {
  static displayName = NavMenu.name;

  constructor (props) {
    super(props);

    this.toggleNavbar = this.toggleNavbar.bind(this);
    this.state = {
      collapsed: true
    };
  }

  toggleNavbar () {
    this.setState({
      collapsed: !this.state.collapsed
    });
  }

  render() {
    return (
      <header>
        <Navbar className="navbar-expand-sm navbar-toggleable-sm ng-white border-bottom box-shadow mb-3" container light>
          <NavbarBrand tag={Link} to="/">ActiveAllocator.API</NavbarBrand>
          <NavbarToggler onClick={this.toggleNavbar} className="mr-2" />
          <Collapse className="d-sm-inline-flex flex-sm-row-reverse" isOpen={!this.state.collapsed} navbar>
            <ul className="navbar-nav flex-grow">
              <NavItem>
                <NavLink tag={Link} to="/">Home</NavLink>
              </NavItem>
              {/*
              <NavItem>
                <NavLink tag={Link} className="text-dark" to={Routes.COUNTER}>Counter</NavLink>
              </NavItem>
              <NavItem>
                <NavLink tag={Link} className="text-dark" to={Routes.FETCH_DATA}>Fetch data</NavLink>
              </NavItem>*/}
              {sessionStorage.getItem('userName') == null &&
                <NavItem>
                  <NavLink tag={Link} to={Routes.LOGIN}>Login</NavLink>
                </NavItem>
              }
              {sessionStorage.getItem('userName') != null &&
                <>
                  <NavItem>
                    <NavLink tag={Link} to={Routes.USERS}>Users</NavLink>
                  </NavItem>
                  <NavItem>
                    <NavLink tag={Link} to={Routes.ACCOUNTS}>Accounts</NavLink>
                  </NavItem>
                  <NavItem>
                    <NavLink tag={Link} to={Routes.ENVELOPES}>Envelopes</NavLink>
                  </NavItem>
                  <NavItem>
                    <NavLink tag={Link} to={Routes.TRANSACTIONS}>Transactions</NavLink>
                  </NavItem>
                  <NavItem>
                    <NavLink tag={Link} to={Routes.APIKEYS}>API Keys</NavLink>
                  </NavItem>
                  <NavItem>
                    <NavLink tag={Link} to={Routes.LOGOUT}>Logout</NavLink>
                  </NavItem>
                </>
              }
            </ul>
          </Collapse>
        </Navbar>
      </header>
    );
  }
}
