import { useNavigate } from "react-router-dom";
import { EndPoints, deleteData, getData } from "../services/AccessAPI";
import { useEffect } from "react";
import { useState } from 'react';
import { useLocation } from 'react-router-dom';
import { Routes } from "../services/Routes";

export default function DeleteAccount() {
    const search = useLocation().search;
    const id = new URLSearchParams(search).get('id')

    useEffect(() => {
        getData(EndPoints.ACCOUNTS + "/" + id).then(
            (result) => {
                if (result) {
                    setState({
                        name: result.name,
                        lastActivity: result.lastActivity,
                        createdOn: result.createdOn,
                        balance: result.balance,
                        initialBalance: result.initialBalance,
                        currencyId: result.currencyId,
                        externalAccountNumber: result.externalAccountNumber,
                        loading: false
                    });
                }
            }
        );
    }, [id])

    let navigate = useNavigate();

    const [state, setState] = useState({
        name: '',
        lastActivity: null,
        createdOn: null,
        balance: 0,
        initialBalance: 0,
        currencyId: 0,
        externalAccountNumber: '',
        loading: true
    });

    function onCancel() {
        navigate(Routes.ACCOUNTS);
    }

    function onConfirmation(e) {
        e.preventDefault();

        deleteData(EndPoints.ACCOUNTS + "/" + id).then((result) => {
            let responseJson = result;
            if (responseJson) {
                navigate(Routes.ACCOUNTS);
            }
        }
        );

    }
    
    return (
        <div>
            <h2>::Delete account::</h2>
            <h3>Are you sure you want to delete this?</h3>
            <div>
                <h4>Account Information</h4>
                <dl className="row">
                    <dt className="col-sm-2">
                        Account Name:
                    </dt>
                    <dd className="col-sm-10">
                        {state.name}
                    </dd>
                </dl>

                <dl className="row">
                    <dt className="col-sm-2">
                        Last Activity:
                    </dt>
                    <dd className="col-sm-10">
                        {state.lastActivity}
                    </dd>
                </dl>

                <dl className="row">
                    <dt className="col-sm-2">
                        Created On:
                    </dt>
                    <dd className="col-sm-10">
                        {state.createdOn}
                    </dd>
                </dl>

                <dl className="row">
                    <dt className="col-sm-2">
                        Balance:
                    </dt>
                    <dd className="col-sm-10">
                        {state.balance}
                    </dd>
                </dl>

                <dl className="row">
                    <dt className="col-sm-2">
                        Initial Balance:
                    </dt>
                    <dd className="col-sm-10">
                        {state.initialBalance}
                    </dd>
                </dl>

                <dl className="row">
                    <dt className="col-sm-2">
                        Currency ID:
                    </dt>
                    <dd className="col-sm-10">
                        {state.currencyId}
                    </dd>
                </dl>

                <dl className="row">
                    <dt className="col-sm-2">
                        External Account Number:
                    </dt>
                    <dd className="col-sm-10">
                        {state.externalAccountNumber}
                    </dd>
                </dl>

                <form onSubmit={onConfirmation}>
                    <input type="hidden" asp-for="Id" />
                    <button onClick={onCancel} className="btn btn-primary">Back to List</button>
                    &nbsp;&nbsp;
                    <button type="submit" className="btn btn-danger">Delete</button>
                </form>
            </div>
        </div>
    )
}