import { useNavigate } from "react-router-dom";
import { EndPoints, deleteData, getData } from "../services/AccessAPI";
import { useEffect } from "react";
import { useState } from 'react';
import { useLocation } from 'react-router-dom';
import { Routes } from "../services/Routes";

export default function DeleteAutoclassrule() {
    const search = useLocation().search;
    const id = new URLSearchParams(search).get('id')

    useEffect(() => {
        getData(EndPoints.AUTOCLASS + "/" + id).then(
            (result) => {
                if (result) {
                    setState({
                        name: result.name,
                        accountId: result.accountId,
                        enabled: result.enabled,
                        expressions: result.expressions,
                        changes: result.changes,
                        loading: false
                    });
                }
            }
        );
    }, [id])

    let navigate = useNavigate();

    const [state, setState] = useState({
        name: '',
        accountId: 0,
        enabled: true,
        expressions: [],
        changes: [],
        loading: true
    });

    function onCancel() {
        navigate(Routes.ACCOUNTS);
    }

    function onConfirmation(e) {
        e.preventDefault();

        deleteData(EndPoints.AUTOCLASS + "/" + id).then((result) => {
            let responseJson = result;
            if (responseJson) {
                navigate(Routes.ACCOUNTS);
            }
        }
        );

    }
    
    return (
        <div>
            <h2>::Delete Autoclass Rule::</h2>
            <h3>Are you sure you want to delete this?</h3>
            <div>
                <h4>Autoclass Rule Information</h4>
                <dl className="row">
                    <dt className="col-sm-2">
                        Name:
                    </dt>
                    <dd className="col-sm-10">
                        {state.name}
                    </dd>
                </dl>

                <dl className="row">
                    <dt className="col-sm-2">
                        Account ID:
                    </dt>
                    <dd className="col-sm-10">
                        {state.accountId}
                    </dd>
                </dl>

                <dl className="row">
                    <dt className="col-sm-2">
                        Enabled:
                    </dt>
                    <dd className="col-sm-10">
                        {state.Enabled}
                    </dd>
                </dl>

                <form onSubmit={onConfirmation}>
                    <input type="hidden" asp-for="Id" />
                    <button type="submit" className="btn btn-danger">Delete</button> |
                    <button onClick={onCancel} className="btn btn-primary">Back to List</button>
                </form>
            </div>
        </div>
    )
}