import { useNavigate } from "react-router-dom";
import { EndPoints, deleteData, getData } from "../services/AccessAPI";
import { useEffect } from "react";
import { useState } from 'react';
import { useLocation } from 'react-router-dom';
import { Routes } from "../services/Routes";

export default function DeleteEnvelope() {
    const search = useLocation().search;
    const id = new URLSearchParams(search).get('id')

    useEffect(() => {
        getData(EndPoints.ENVELOPES + "/" + id).then(
            (result) => {
                if (result) {
                    setState({
                        name: result.name,
                        accountId: result.accountId,
                        enabled: result.enabled,
                        isPersistant: result.isPersistant,
                        priority: result.priority,
                        balance: result.balance,
                        initialBalance: result.initialBalance,
                        fundingMethods: result.fundingMethods,
                        loading: false
                    });
                }
            }
        );
    }, [id])

    let navigate = useNavigate();

    const [state, setState] = useState({
        name: '',
        accountId: 0,
        enabled: true,
        isPersistant: true,
        priority: 0,
        balance: 0,
        initialBalance: 0,
        fundingMethods: [],
        loading: true
    });

    function onCancel() {
        navigate(Routes.ENVELOPES);
    }

    function onConfirmation(e) {
        e.preventDefault();

        deleteData(EndPoints.ENVELOPES + "/" + id).then((result) => {
            let responseJson = result;
            if (responseJson) {
                navigate(Routes.ENVELOPES);
            }
        });
    }
    
    return (
        <div>
            <h2>::Delete Envelope::</h2>
            <h3>Are you sure you want to delete this?</h3>
            <div>
                <h4>Envelope Information</h4>
                <dl className="row">
                    <dt className="col-sm-2">
                        Envelope Name:
                    </dt>
                    <dd className="col-sm-10">
                        {state.name}
                    </dd>
                </dl>

                <dl className="row">
                    <dt className="col-sm-2">
                        Account Id:
                    </dt>
                    <dd className="col-sm-10">
                        {state.accountId}
                    </dd>
                </dl>

                <dl className="row">
                    <dt className="col-sm-2">
                        Enabled:
                    </dt>
                    <dd className="col-sm-10">
                        {state.enabled}
                    </dd>
                </dl>

                <dl className="row">
                    <dt className="col-sm-2">
                        Is Persistant:
                    </dt>
                    <dd className="col-sm-10">
                        {state.isPersistant}
                    </dd>
                </dl>

                <dl className="row">
                    <dt className="col-sm-2">
                        Priority:
                    </dt>
                    <dd className="col-sm-10">
                        {state.priority}
                    </dd>
                </dl>

                <dl className="row">
                    <dt className="col-sm-2">
                        Balance:
                    </dt>
                    <dd className="col-sm-10">
                        {state.balance}
                    </dd>
                </dl>

                <dl className="row">
                    <dt className="col-sm-2">
                        Initial Balance:
                    </dt>
                    <dd className="col-sm-10">
                        {state.initialBalance}
                    </dd>
                </dl>

                <dl className="row">
                    <dt className="col-sm-2">
                        Funding Methods:
                    </dt>
                    <dd className="col-sm-10">
                        
                    </dd>
                </dl>

                <form onSubmit={onConfirmation}>
                    <input type="hidden" asp-for="Id" />
                    <button onClick={onCancel} className="btn btn-primary">Back to List</button>
                    &nbsp;&nbsp;
                    <button type="submit" className="btn btn-danger">Delete</button>
                </form>
            </div>
        </div>
    )
}