import React from 'react';

export const RenderType = {
    MoneyUnsigned: "money-unsigned",
    MoneySigned: "money-signed",
    MoneyNoColor: "money-nocolor",
    MoneyNothing: "money-nothing",
    Date: "date-render-type"
}

export default function DataFormatter({
    data,
    renderType,
    currencySymbol = "$"
}) {

    /*const isNotUndefinedOrNull = (object) => {
        return !(object === undefined || object === null);
    }*/

    function filterData(data) {
        if (renderType !== undefined && renderType !== null && data !== null) {
            let num = Number(data)
            let moneySign = true;

            switch (renderType)
            {
                case RenderType.MoneyUnsigned:
                    moneySign = false;
                case RenderType.MoneySigned:
                    if (num >= 0) {
                        return <span className='text-success'>{ moneySign && "+"}{currencySymbol + (Math.round(num * 100) / 100).toFixed(2)}</span>
                    } else {
                        return <span className='text-danger'>{ moneySign && "-"}{currencySymbol + (Math.round(num * -100) / 100).toFixed(2)}</span>
                    }
                case RenderType.MoneyNoColor:
                    if (num >= 0) {
                        return moneySign && "+" + currencySymbol + (Math.round(num * 100) / 100).toFixed(2)
                    } else {
                        return moneySign && "-" + currencySymbol + (Math.round(num * -100) / 100).toFixed(2)
                    }
                case RenderType.MoneyNothing:
                    return currencySymbol + (Math.round(Math.abs(num) * 100) / 100).toFixed(2)
                case RenderType.Date:
                    return data.split('T')[0];
                default:
                    return data;
            }
        }

        return data
    }
    
    return (
        filterData(data)
    );
}