import { useNavigate } from "react-router-dom";
import { EndPoints, deleteData, getData } from "../services/AccessAPI";
import { useEffect } from "react";
import { useState } from 'react';
import { useLocation } from 'react-router-dom';
import { Routes } from "../services/Routes";

export default function DeleteUser() {
    const search = useLocation().search;
    const id = new URLSearchParams(search).get('id')

    useEffect(() => {
        //const { id } = this.props.match.params;

        getData(EndPoints.USERS + "/" + id).then(
            (result) => {
                console.log("Role for edit: ");
                console.log(result);
                if (result) {
                    setState({
                        firstName: result.firstName,
                        lastName: result.lastName,
                        username: result.username,
                        email: result.email,
                        roles: result.roles,
                        loading: false
                    });
                }
            }
        );
    }, [id])

    let navigate = useNavigate();

    const [state, setState] = useState({
        firstName: '',
        lastName: '',
        username: '',
        email: '',
        roles: [],
        loading: true
    });

    function onCancel() {
        navigate(Routes.USERS);
    }

    function onConfirmation(e) {
        e.preventDefault();

        deleteData(EndPoints.USERS + "/" + id).then((result) => {
            let responseJson = result;
            if (responseJson) {
                navigate(Routes.USERS);
            }
        }
        );

    }

    return (
        <div>
            <h2>::Delete user::</h2>
            <h3>Are you sure you want to delete this?</h3>
            <div>
                <h4>User Information</h4>
                <dl className="row">
                    <dt className="col-sm-2">
                        First Name:
                    </dt>
                    <dd className="col-sm-10">
                        {state.firstName}
                    </dd>
                </dl>

                <dl className="row">
                    <dt className="col-sm-2">
                        Last Name:
                    </dt>
                    <dd className="col-sm-10">
                        {state.lastName}
                    </dd>
                </dl>

                <dl className="row">
                    <dt className="col-sm-2">
                        User Name:
                    </dt>
                    <dd className="col-sm-10">
                        {state.username}
                    </dd>
                </dl>

                <dl className="row">
                    <dt className="col-sm-2">
                        Email:
                    </dt>
                    <dd className="col-sm-10">
                        {state.email}
                    </dd>
                </dl>

                <form onSubmit={onConfirmation}>
                    <input type="hidden" asp-for="Id" />
                    <button onClick={onCancel} className="btn btn-primary">Back to List</button>
                    &nbsp;&nbsp;
                    <button type="submit" className="btn btn-danger">Delete</button>
                </form>
            </div>
        </div>
    )
}