using System.Collections.Generic;
using System.Data;
using System.Text.Json.Serialization;

namespace ActiveAllocator.API.Entities;

public class Envelope
{
    public int Id { get; set; }
    public string Name { get; set; }
    public Account Account { get; set; }
    public bool Enabled { get; set; }
    public TimeSpan Period { get; set; }
    public bool IsPersistant { get; set; }
    public int Priority { get; set; }
    public decimal Balance { get; set; }
    public decimal InitialBalance { get; set; }
    public DateTime? LastTriggeredOn { get; set; }
    public IEnumerable<EnvelopeFundingMethod> FundingMethods { get; set; }

    public string GetLogString()
    {
        return $"'{Name}' (id={Id})";
    }
}