﻿using System;
using Microsoft.EntityFrameworkCore.Migrations;
using Npgsql.EntityFrameworkCore.PostgreSQL.Metadata;

#nullable disable

namespace ActiveAllocator.API.Migrations
{
    /// <inheritdoc />
    public partial class EnvelopeEntity : Migration
    {
        /// <inheritdoc />
        protected override void Up(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.DropForeignKey(
                name: "FK_Operations_Allocs_AllocId",
                table: "Operations");

            migrationBuilder.DropTable(
                name: "Allocs");

            migrationBuilder.DropIndex(
                name: "IX_Operations_AllocId",
                table: "Operations");

            migrationBuilder.DropColumn(
                name: "AllocId",
                table: "Operations");

            migrationBuilder.CreateTable(
                name: "Envelopes",
                columns: table => new
                {
                    Id = table.Column<int>(type: "integer", nullable: false)
                        .Annotation("Npgsql:ValueGenerationStrategy", NpgsqlValueGenerationStrategy.IdentityByDefaultColumn),
                    Name = table.Column<string>(type: "text", nullable: false),
                    AccountId = table.Column<int>(type: "integer", nullable: false),
                    Enabled = table.Column<bool>(type: "boolean", nullable: false),
                    Period = table.Column<TimeSpan>(type: "interval", nullable: false),
                    IsPersistant = table.Column<bool>(type: "boolean", nullable: false),
                    Priority = table.Column<int>(type: "integer", nullable: false),
                    Balance = table.Column<decimal>(type: "numeric", nullable: false),
                    InitialBalance = table.Column<decimal>(type: "numeric", nullable: false),
                    LastTriggeredOn = table.Column<DateTime>(type: "timestamp with time zone", nullable: true)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_Envelopes", x => x.Id);
                    table.ForeignKey(
                        name: "FK_Envelopes_Accounts_AccountId",
                        column: x => x.AccountId,
                        principalTable: "Accounts",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.Cascade);
                });

            migrationBuilder.CreateIndex(
                name: "IX_Envelopes_AccountId",
                table: "Envelopes",
                column: "AccountId");
        }

        /// <inheritdoc />
        protected override void Down(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.DropTable(
                name: "Envelopes");

            migrationBuilder.AddColumn<int>(
                name: "AllocId",
                table: "Operations",
                type: "integer",
                nullable: true);

            migrationBuilder.CreateTable(
                name: "Allocs",
                columns: table => new
                {
                    Id = table.Column<int>(type: "integer", nullable: false)
                        .Annotation("Npgsql:ValueGenerationStrategy", NpgsqlValueGenerationStrategy.IdentityByDefaultColumn),
                    AccountId = table.Column<int>(type: "integer", nullable: false),
                    CurrentBalance = table.Column<decimal>(type: "numeric", nullable: false),
                    Enabled = table.Column<bool>(type: "boolean", nullable: false),
                    LastBalanceAdded = table.Column<decimal>(type: "numeric", nullable: false),
                    LastTriggeredOn = table.Column<DateTime>(type: "timestamp with time zone", nullable: false),
                    Name = table.Column<string>(type: "text", nullable: false),
                    Period = table.Column<TimeSpan>(type: "interval", nullable: false),
                    PersistanceEnabled = table.Column<bool>(type: "boolean", nullable: false)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_Allocs", x => x.Id);
                    table.ForeignKey(
                        name: "FK_Allocs_Accounts_AccountId",
                        column: x => x.AccountId,
                        principalTable: "Accounts",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.Cascade);
                });

            migrationBuilder.CreateIndex(
                name: "IX_Operations_AllocId",
                table: "Operations",
                column: "AllocId");

            migrationBuilder.CreateIndex(
                name: "IX_Allocs_AccountId",
                table: "Allocs",
                column: "AccountId");

            migrationBuilder.AddForeignKey(
                name: "FK_Operations_Allocs_AllocId",
                table: "Operations",
                column: "AllocId",
                principalTable: "Allocs",
                principalColumn: "Id");
        }
    }
}
