using System.Collections;
using System.Collections.Generic;
using System.Text.Json.Serialization;
using ActiveAllocator.API.Entities;

namespace ActiveAllocator.API.Models.Autoclass;

public class AutoclassRuleDTO
{
    public int Id { get; set; }
    public string Name { get; set; }
    public int AccountId { get; set; }
    public IEnumerable<AutoclassExpressionDTO> Expressions { get; set; }
    public IEnumerable<AutoclassChangeDTO> Changes { get; set; }
    public bool Enabled { get; set; }
}

public class AutoclassExpressionDTO
{
    public AutoclassTransactionField TransactionField { get; set; }
    public AutoclassCompareOperator CompareOperator { get; set; }
    public string Value { get; set; }
}

public class AutoclassChangeDTO
{
    public AutoclassTransactionField Field { get; set; }
    public string Value { get; set; }
}