namespace ActiveAllocator.API.Models.Autoclass;

using System.ComponentModel.DataAnnotations;
using System.Runtime.InteropServices;
using ActiveAllocator.API.Entities;
using System.Collections.Generic;

public class AutoclassRuleCreateRequest
{
    public string Name { get; set; }
    public int AccountId { get; set; }
    public IEnumerable<AutoclassExpressionCreateRequest> Expressions { get; set; }
    public IEnumerable<AutoclassChangeCreateRequest> Changes { get; set; }
    public bool Enabled { get; set; }
    public bool? TriggerOnCreate { get; set; } = null;
}

public class AutoclassExpressionCreateRequest
{
    public AutoclassTransactionField TransactionField { get; set; }
    public AutoclassCompareOperator CompareOperator { get; set; }
    public string Value { get; set; }
}

public class AutoclassChangeCreateRequest
{
    public AutoclassTransactionField Field { get; set; }
    public string Value { get; set; }
}