namespace ActiveAllocator.API.Models.Envelopes;

using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.Runtime.InteropServices;
using ActiveAllocator.API.Entities;

public class EnvelopeCreateRequest
{
    public string Name { get; set; }
    public int Account { get; set; }
    public string InitialBalance { get; set; }
    public bool Enabled { get; set; }
    public bool IsPersistant { get; set; }
    public int Priority { get; set; }
    public string ExternalAccountNumber { get; set; }
    public IEnumerable<EnvelopeFundingMethodCreateRequest> FundingMethods { get; set; }
}

public class EnvelopeFundingMethodCreateRequest
{
    public int Order { get; set; }
    public EnvelopeFundingMethodModes Mode { get; set; }
    public string Value { get; set; }
    public int PeriodsToLookback { get; set; } = 0;
}
