using System.Collections;
using System.Collections.Generic;
using System.Text.Json.Serialization;
using ActiveAllocator.API.Entities;

namespace ActiveAllocator.API.Models.Envelopes;

public class EnvelopeDTO
{
    public int Id { get; set; }
    public string Name { get; set; }
    public int AccountId { get; set; }
    public bool Enabled { get; set; }
    public TimeSpan Period { get; set; }
    public bool IsPersistant { get; set; }
    public int Priority { get; set; }
    public decimal Balance { get; set; }
    public decimal InitialBalance { get; set; }
    public DateTime? LastTriggeredOn { get; set; }
    public IEnumerable<EnvelopeFundingMethodDTO> FundingMethods { get; set; }
}

public class EnvelopeFundingMethodDTO
{
    public int Order { get; set; }
    public EnvelopeFundingMethodModes Mode { get; set; }
    public string Value { get; set; }
    public int PeriodsToLookback { get; set; } = 0;
}