using System.Collections.Generic;
using System.Runtime;
using ActiveAllocator.API.Services;

namespace ActiveAllocator.API.Models.Transactions;

public class TransactionCreate
{
    public DateTime Date { get; set; }
    public string ExternalId { get; set; }
    public string Description { get; set; }
    public int? DebitAccount { get; set; }
    public int? CreditAccount { get; set; }
    public int? DebitEnvelope { get; set; }
    public int? CreditEnvelope { get; set; }
    public bool? IsEnvelopeFundingTransaction { get; set; } = null;
    public decimal Amount { get; set; }
    public int CurrencyType { get; set; }
    public string Notes { get; set; }
    public bool IsPending { get; set; }
    public List<string>? Tags { get; set; } = null;
    public bool? TriggerAutoclassRules { get; set; } = null;
}

/*
// TransactionCreate myDeserializedClass = JsonConvert.DeserializeObject<TransactionCreate>(myJsonResponse);
{
    "Owner":1,
    "SplitDescription":"string",
    "UreatedOn":"2018-09-17T12:46:47+01:00",
    "UpdatedOn":"2018-09-17T12:46:47+01:00",
    "ExternalId":"string",
    "Transactions":[
        {
            "Description":"string",
            "DebitAccount":1,
            "CreditAccount":1,
            "Amount":"string",
            "CreatedOn":"2018-09-17T12:46:47+01:00",
            "UpdatedOn":"2018-09-17T12:46:47+01:00",
            "ExternalId":"string",
            "CreditAccount":1,
            "Notes":"string",
            "IsPending":true
        }
    ]
}*/