namespace ActiveAllocator.API.Models.Users;

using System.ComponentModel.DataAnnotations;
using ActiveAllocator.API.Entities;

public class RegisterRequest
{
    [Required]
    public string Username { get; set; }

    [Required]
    public string FirstName { get; set; }

    [Required]
    public string LastName { get; set; }

    [Required]
    [EnumDataType(typeof(Role))]
    public string Role { get; set; }

    [Required]
    [EmailAddress]
    public string Email { get; set; }

    [Required]
    [MinLength(6)]
    public string Password { get; set; }
}